function [G] = Wgaborfilter(scale, orientation, a);

expand = 20; b = scale * expand; 
theta = (pi * orientation)/180; 
for x0 = -b : b
    for y0 = -b : b
        x = (x0 * cos(theta) + y0 * sin(theta))/scale;
        y = (y0 * cos(theta) - x0 * sin(theta))/scale;
        g = exp(-(4*x^2+y^2)/100)/50/pi/scale^2; 
        Gauss(b+x0+1,b+y0+1) = g; 
        Gcos(b+x0+1, b+y0+1) = g*cos(x);
        Gsin(b+x0+1, b+y0+1) = g*sin(x);
    end
end

s = sum(Gauss(:)); sc = sum(Gcos(:)); r = sc/s; 
Gcos = Gcos - Gauss*r; 
Scos = sqrt(sum(sum(Gcos.^2))); Ssin = sqrt(sum(sum(Gsin.^2)));
Gcos = Gcos/Scos; Gsin = Gsin/Ssin; 
Gsmall = Gcos + sqrt(-1)*Gsin; 
G = zeros(a+a+1) + sqrt(-1)*zeros(a+a+1); 
G(a+1-b:a+1+b, a+1-b:a+1+b) = Gsmall;  






